unit hlEdit1_2Impl;

interface

uses
  Classes, Controls, StdCtrls, Messages;

type
  ThlAlignment = (taLeft, taCenter, taRight);

  ThlEdit = class(TCustomEdit)
  private
    FAlignment: ThlAlignment;
    procedure SetAlignment(Value: ThlAlignment);
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Alignment: ThlAlignment read FAlignment write SetAlignment default taRight;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;


procedure Register;

implementation

uses
  Windows;

constructor ThlEdit.Create(AOwner: TComponent);
begin
  inherited;
  FAlignment := taRight;
end;

{
  Note: the alignment styles only work when the multiline
  style is set.
}
procedure ThlEdit.CreateParams(var Params: TCreateParams);
begin
  inherited;

  if FAlignment <> taLeft then
  begin
    Params.Style := Params.Style and not ES_LEFT;
    Params.Style := Params.Style or ES_MULTILINE;
    if FAlignment = taRight then
      Params.Style := Params.Style or ES_RIGHT
    else
      Params.Style := Params.Style or ES_CENTER;
  end;
end;

{
  Don't ask for Tab and Return keys!!
}
procedure ThlEdit.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  inherited;
  Message.Result := Message.Result and not DLGC_WANTTAB;
  Message.Result := Message.Result and not DLGC_WANTALLKEYS;
end;

procedure ThlEdit.SetAlignment(Value: ThlAlignment);
begin
  if Value = FAlignment then
    Exit;
  FAlignment := Value;
  RecreateWnd;
end;

procedure Register;
begin
  RegisterComponents('Heelana', [ThlEdit]);
end;


end.